/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.examples.ejb.stateful;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.jfox.examples.ejb.stateless.TestStatelessHome;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class TestStatefulBean implements SessionBean {
    private String word = "Hello,Stateful SessionBean!";

    public TestStatefulBean() {
    }

    public void setSessionContext(SessionContext sessionContext) throws EJBException {
    }

    public void ejbRemove() throws EJBException {
    }

    public void ejbActivate() throws EJBException {
    }

    public void ejbPassivate() throws EJBException {
    }

    public void ejbCreate() throws CreateException {
    }

    public void ejbCreate(String name) throws CreateException {
        this.word = name;
    }

    public String getName() {
        return word;
    }

    private static TestStatelessHome getTestStatelessOnePhase() throws Exception {
        Context ctx = new InitialContext();
        Object home = ctx.lookup("java:comp/env/ejb/TestStatelessEJB");
        TestStatelessHome statelessHome = (TestStatelessHome) javax.rmi.PortableRemoteObject.narrow(home, TestStatelessHome.class);
        return statelessHome;
    }

    private static TestStatelessHome getTestStatelessTwoPhase() throws Exception {
        Context initCtx = new InitialContext();
        Context ctx = (Context) initCtx.lookup("java:comp/env");
        Object home = ctx.lookup("ejb/TestStatelessEJB");
        TestStatelessHome statelessHome = (TestStatelessHome) javax.rmi.PortableRemoteObject.narrow(home, TestStatelessHome.class);
        return statelessHome;
    }
    

    public void setName(String word) {
        this.word = word;
    }
}
