package org.jfox.ioc.management.http;

import javax.servlet.http.HttpServletRequest;

import org.apache.velocity.context.Context;
import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentMeta;
import org.jfox.ioc.ComponentName;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class InstantiateServlet extends SuperServlet {

    public String getTemplate() {
        return "instantiate.vm";
    }

    public void buildContext(HttpServletRequest request, Context ctx) throws Exception {
        String _componentName = request.getParameter("componentname");
        ComponentName componentName = ComponentName.parseString(_componentName,getRegistry().getClassLoaderRepository());

        ComponentMeta meta = getRegistry().getComponentMeta(componentName);
        Component component = getRegistry().getComponentInstance(componentName);

        ctx.put("title","Instantiate Result View");
        ctx.put("componentName",_componentName);
        ctx.put("description",meta.getDescription());
        ctx.put("component",component);

    }

    public static void main(String[] args) {

    }
}

