package org.jfox.ioc.management.http;

import javax.servlet.http.HttpServletRequest;

import org.apache.velocity.context.Context;
import org.jfox.ioc.ComponentMeta;
import org.jfox.ioc.ComponentName;
import org.jfox.ioc.ext.ManagableComponent;
import org.jfox.ioc.management.ManagementInfo;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class ViewServlet extends SuperServlet {

    public String getTemplate() {
        return "view.vm";
    }

    public void buildContext(HttpServletRequest request, Context ctx) throws Exception {
        // Test Session
        request.getSession(true).setAttribute("A","B");

        String _componentName = request.getParameter("componentname");
        ComponentName componentName = ComponentName.parseString(_componentName,getRegistry().getClassLoaderRepository());

        ComponentMeta meta = getRegistry().getComponentMeta(componentName);

        ctx.put("title","Component View");
        ctx.put("componentMeta",meta);

        if(!ManagableComponent.class.isAssignableFrom(meta.getComponentImplementation())) {
            ctx.put("managable",false);
        }
        else {
            ctx.put("managable",true);
            ManagementInfo mgtInfo = meta.getManagementInfo();
            ctx.put("managementInfo",mgtInfo);
        }
        
    }

    public static void main(String[] args) {

    }
}

