#!/bin/sh

if [ "x$JAVA_HOME" = "x" ]; then
	echo " Error: please set JAVA_HOME environment first!"
	exit 1;
fi

# cygwin compatiable
cygwin=false;
case "`uname`" in  CYGWIN*)
  cygwin=true ;
esac

MAIN_CLASS=org.jfox.ioc.Startup

HOTSPOT=`java -version 2>&1 | grep HotSpot`"x"
if [ "$HOTSPOT" != "x" ]; then
       HOTSPOT="-server"
else
       HOTSPOT=""
fi

JFOX_CLASSPATH=../conf:../jfoxco/classes:../jfoxco/lib/log4j-1.2.8.jar
if $cygwin; then
  JFOXCO_CLASSPATH=`cygpath --path --windows "$JFOXCO_CLASSPATH"`
fi

if $cygwin; then
  JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
fi


JFOXCO_MEMORY_OPTS="-Xms128m -Xmx512m"

JFOXCO_GC_OPTS=""

echo "======================================="
echo "  JFox IoC Kernel"
echo "  JAVA_HOME: $JAVA_HOME"
echo "  Memory Options: $JFOXCO_MEMORY_OPTS"
echo "  GC Options: $JFOXCO_GC_OPTS"
echo "======================================="

$JAVA_HOME/bin/java $HOTSPOT $JFOXCO_MEMORY_OPTS -classpath $JFOXCO_CLASSPATH $MAIN_CLASS 2>&1 &