/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc;

import org.jfox.ioc.exception.ComponentException;


/**
 * ע Component  Key
 * ɣtypefactortype Ϊ Class
 * factorΪעӣͬһComponentĲͬע
 * ָfactorϵͳԶʹtypehashCodeΪӡ
 * <br><br>
 * ComponentNameַʽ: type@factor
 * Ҳṩ̬ newInstance ַɶ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ComponentName {
    /**
     * Component type class name
     * type ǽӿڣҲʵ
     */
    private Class type = null;

    /**
     * עComponentʱʹõӣͬһComponentĲͬע
     */
    private String factor = null;


    /**
     *
     * @param clz
     * @param factory
     */
    private ComponentName(Class clz, String factory) {
        this.type = clz;
        if(factory == null || factory.trim().equals("")) {
            this.factor = "" + System.identityHashCode(clz);
        }
        else {
            this.factor = factory;
        }
    }
    /**
     * һµ ComponentName 
     *
     * @param type Component Class
     * @return  compClass  factor ɵ ComponentName 
     */
    public static ComponentName newInstance(Class type) {
        return newInstance(type, null);
    }

    /**
     * һµ ComponentName 
     * @param type Component Class
     * @param factor ComponentӣComponent ID factor Ϊջ null,ʹ type  hashCode
     * @return  type  factor ɵ ComponentName 
     */
    public static ComponentName newInstance(Class type, String factor) {
        return new ComponentName(type, factor);
    }

    /**
     * ַComponentNameַʽ "className@factor"磺org.jfox.TestComponent@default
     * classNameַ Class ʱʹõǰ̵߳ ClassLoader
     * ʹõǰ̵߳ ClassLoaderʹ {@link #parseString(String, ClassLoader)}
     *
     *  factor Ϊ(className@)ʹװ֮ Component ClasshashCode
     * @param compName ַComponentName
     * @throws ComponentException
     * @see #parseString(String, ClassLoader)
     */
    public static ComponentName parseString(String compName) throws ComponentException {
        return parseString(compName, Thread.currentThread().getContextClassLoader());
    }

    /**
     * ַComponentNameַʽ "className@factor"磺org.jfox.TestComponent@default
     * classNameַ Class ʱʹָ ClassLoader
     *
     * @param compName ַComponentName
     * @param cl װClassLoader
     */
    public static ComponentName parseString(String compName, ClassLoader cl) throws ComponentException {
        String className = compName;
        int index = compName.indexOf("@");
        if(index > 0) {
            className = compName.substring(0, index);
            String factor = compName.substring(index + 1);
            try {
                Class clz = cl.loadClass(className);
                return newInstance(clz, factor);
            }
            catch(ClassNotFoundException e) {
                throw new ComponentException(e);
            }
        }
        else {
            try {
                Class clz = cl.loadClass(className);
                return newInstance(clz);
            }
            catch(ClassNotFoundException e) {
                throw new ComponentException(e);
            }
        }

    }

    /**
     * õ Component  Class
     * @return
     */
    public Class getType() {
        return type;
    }

    /**
     * õ ComponentName 
     * @return
     */
    public String getFactor() {
        return factor;
    }

    public String toString() {
        return type.getName() + "@" + factor;
    }

    public int hashCode() {
        return type.hashCode() + factor.hashCode();
    }

    /**
     * type class  factor 
     * @param obj
     * @return
     */
    public boolean equals(Object obj) {
        if(!(obj instanceof ComponentName)) {
            return false;
        }
        else {
            ComponentName _name = (ComponentName) obj;
            return type.equals(_name.type) && factor.equals(_name.factor);
        }
    }

    public static void main(String[] args) {

    }
}

