/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc;

import org.jfox.ioc.depend.ComponentRefDependency;
import org.jfox.ioc.depend.Dependency;
import org.jfox.ioc.depend.ObjectDependency;
import org.jfox.ioc.deploy.ComponentDeployer;
import org.jfox.ioc.deploy.DeployMonitor;

/**
 * ෢ HttpManagement  DeployMonitor 
 * Ĭ DeployMonitor ʹ ./modules Ŀ¼Ϊģ鲿Ŀ¼
 * Ȼ RegistryDeployMonitor ᷢ ./modules Ŀ¼µĸģ
 *
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class Startup {

    /**
     *
     * @param args һΪģ鲿Ŀ¼
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        String moduleDir = "./modules";
        if(args !=null && args.length !=0){
            if(!args[0].trim().equals("")) {
                moduleDir = args[0].trim();
            }
        }

        Registry registry = Registry.getInstance();
        registry.registerComponent(ComponentDeployer.class);
        ComponentMeta meta = registry.registerComponent(DeployMonitor.class,
                new Dependency[]{
                    new ComponentRefDependency(ComponentName.newInstance(ComponentDeployer.class)),
                    new ObjectDependency(moduleDir)});
        registry.getComponentInstance(meta.getComponentName());
        // registryregistryעķDeployMonitor modulesµ
        registry.start();
    }
}
