/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc.classloader;

import java.net.URL;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class LocalClassLoader extends URLClassLoader {
    /**
     * global Class ClassLoaderRepository
     */
    private ClassLoaderRepository repo;

    // װģ lib µİΪ˽࣬ module
    private PrivateURLClassLoader privateCL = null;

    /**
     * the jars in the urls can be load by Repository
     *
     * @param urls
     */
    public LocalClassLoader(URL[] urls, ClassLoaderRepository repo) {
        super(urls, repo);
        privateCL = new PrivateURLClassLoader(new URL[0], ClassLoader
                                                          .getSystemClassLoader());
        this.repo = repo;
        repo.addLocalCL(this);
    }

    public Class<?> loadClass(String name) throws ClassNotFoundException {
        try {
            Class c = super.loadClass(name);
            // ֻʹLocalClassLoaderװصŻ棬п SystemClassLoader װص
            if(c.getClassLoader() == this) {
                repo.cacheClass(c);
            }
            return c;

        }
        catch(ClassNotFoundException e2) {
            try {
                return privateCL.loadClass(name);
            }
            catch(ClassNotFoundException e4) {

            }
        }
        throw new ClassNotFoundException(name);

    }

    /**
     * ɹװأ repo 棻 װʧܣ repo  ʧܣ׳쳣
     *
     * @param name
     * @param resolve
     * @return
     * @throws ClassNotFoundException
     */
//    protected synchronized Class loadClass(String name, boolean resolve)
//            throws ClassNotFoundException {

//        try {
        //װ common lib е
//            return repo.loadClassSuper(name);
//            return getParent().loadClass(name);
//        }
//        catch(ClassNotFoundException e0) {
//    }

    /*
    * ʵ findClassһ౻װصĴΪ ͨ privateCLװصûл
    * LocalClassLoader ÿloadʱ ǻ findClass ңfindClass
    * ûʹûװعܣfindLoadedClass(name)  privateCL  find ࣬Ѿװˣᱨ
    * protected Class findClass(String name) throws ClassNotFoundException {
    * try { return super.findClass(name); } catch(ClassNotFoundException e) {
    * try { // ʹ˽װrepo return privateCL.findClass(name); }
    * catch(ClassNotFoundException e1) { } } throw new
    * ClassNotFoundException(name);
    *  }
    */

    /**
     * ·privateClassLoaderУ LocalClassLoader·ͨ
     *
     * @param url
     */
    public void addURL(URL url) {
        privateCL.addURL(url);
    }

    public URL getResource(String name) {
        URL url = super.getResource(name);
        if(url == null) {
            url = repo.getResource(name);
        }
        return url;

    }

    /**
     * jsper ʱҪõ urlsԱrepo urls
     *
     * @return
     */
    public URL[] getURLs() {
        List urls = new ArrayList();
        urls.addAll(Arrays.asList(repo.getURLs()));
        urls.addAll(Arrays.asList(super.getURLs()));
        return (URL[]) urls.toArray(new URL[0]);
    }


    public String toString() {
        return "LocalClassLoader" + Arrays.asList(getURLs());
    }
}

