/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.ioc.common;

import java.text.NumberFormat;

import org.jfox.ioc.ComponentContext;
import org.jfox.ioc.annotation.Managable;
import org.jfox.ioc.ext.ActiveComponent;
import org.jfox.ioc.ext.ManagableComponent;
import org.jfox.ioc.ext.SingletonComponent;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class SysMonitor implements ManagableComponent, ActiveComponent, SingletonComponent{
    private static NumberFormat format = NumberFormat.getInstance();;

    @Managable
    public String getTotalMemory() {
        long m = (long) (Runtime.getRuntime().totalMemory() / 1024);
        return format.format(m) + " K";
    }

    @Managable
    public String getFreeMemory() {
        long m = (long) (Runtime.getRuntime().freeMemory() / 1024);
        return format.format(m) + " K";
    }

    @Managable
    public String getMaxMemory() {
        long m = (long) (Runtime.getRuntime().maxMemory() / 1024);
        return format.format(m) + " K";
    }

    @Managable
    public int getThreadCount() {
        return Thread.activeCount();
    }

    @Managable
    public void gc() {
        System.gc();
    }

    public void setComponentContext(ComponentContext ctx) {
    }

    public static void main(String[] args) {

    }
}

