/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.connector;

import java.io.IOException;
import java.lang.reflect.Method;
import java.rmi.MarshalledObject;

import org.jfox.ioc.util.Marshaller;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public abstract class AbstractInvocation implements Invocation {
    private ObjectId objectId = null;

    private String methodHash = null;
    private Object[] args = null;

    /**
     * Զ̵õķ
     * Զ̵õʱ򣬴ȥʱֻ methodHashڷͨmethodHashŵõMethod
     */
    private transient Method method = null;

	/**
	 * 洢ִжҪEJB Bean
	 * //TODO: ҪȺƵ
	 */
    private transient Object targetObject = null;

	private boolean clustable = false;

    public AbstractInvocation(ObjectId objectId, String methodHash, Object[] args) {
        this.objectId = objectId;
        this.methodHash = methodHash;
        this.args = args;
    }

    public ObjectId getObjectId() {
        return objectId;
    }

    public String getMethodHash() {
        return methodHash;
    }

    public Object[] getArgs() {
        return args;
    }

    public void setMethod(Method method) {
        this.method = method;
    }

    public Method getMethod() {
        return method;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("Invocation {type=");
        sb.append(this.getClass().getName());
        sb.append(",objectId=");
        sb.append(objectId);
        if(method != null){
            sb.append(", method=");
            sb.append(method.getName());
        }
        sb.append(", methodHash=");
        sb.append(methodHash);
        sb.append("}");
        return sb.toString();
    }

    public synchronized Object getTargetObject() {
	    if(( targetObject != null) && (targetObject instanceof MarshalledObject)) {
		    targetObject = Marshaller.unmarshall(targetObject);
	    }
        return targetObject;
    }

    public void setTargetObject(Object targetObject) {
        this.targetObject = targetObject;
    }

	public boolean isClustable() {
		return clustable;
	}

	public void setClustable(boolean clustable) {
		this.clustable = clustable;
	}

	private void writeObject(java.io.ObjectOutputStream out)
			throws IOException {
		out.defaultWriteObject();
		out.writeObject(Marshaller.marshall(targetObject));
	}

	private void readObject(java.io.ObjectInputStream in)
			throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		targetObject = in.readObject();
	}


	public static void main(String[] args) {

    }
}
