/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.connector;

/**
 * Ⱥͨţ ClusterInvocation Ķ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ClusterHandler extends AbstractHandler implements ClusterContainer {
	/**
	 * ConnectorHandler 
	 */
	private transient HandlerManager handlerManager = HandlerManager.getInstance();

	public ClusterHandler() {

    }

    public Class getInvocationClass() {
        return ClusterInvocation.class;
    }

	public Object execute(Invocation invocation) throws Throwable {
		ClassLoader oldCl = Thread.currentThread().getContextClassLoader();
		try {
			sync(invocation);
		}
		finally{
			Thread.currentThread().setContextClassLoader(oldCl);
		}
		return null;
	}

	public void sync(Invocation invocation) {

	    // жԼڵΪClusterServerѾ
	    ClusterInvocation clusterInvocation = (ClusterInvocation)invocation;
	    Invocation innerInvocation = clusterInvocation.getInvocation();
		Handler handler = handlerManager.getHandler(innerInvocation.getClass());

		Container container = handler.getContainer();
		if(!(container instanceof ClusterableContainer)){
			logger.warn("Invocation " + innerInvocation.getClass().getName() + " 's Container " + container.getClass().getName() + " is not a ClusterableContainer.");
			return;
		}
		innerInvocation.setMethod(handler.getMethodByHash(innerInvocation.getMethodHash()));


		/**
	     * ӦʹHandlerClassLoader
	     */
		ClassLoader oldCL = Thread.currentThread().getContextClassLoader();
	    ClassLoader cl = handler.getClass().getClassLoader();
		try {
	        Thread.currentThread().setContextClassLoader(cl);
	        ((ClusterableContainer) container).syncInvocation(innerInvocation);
		}
		finally{
			Thread.currentThread().setContextClassLoader(oldCL);
		}

    }

    public Class getHandlerClass() {
        return this.getClass();
    }

}
