/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */

package org.jfox.ioc.connector;

import java.io.IOException;
import java.rmi.MarshalledObject;

import org.jfox.ioc.util.Marshaller;

/**
 * һȺÿһ߸ƶĲ
 *
 * õӦ A5_InstancePoolHandler 
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ClusterInvocation extends AbstractInvocation {

    private transient Invocation invocation = null;
	private ServerNode theNode = null;
	private transient MarshalledObject invocationMobj = null;

	public ClusterInvocation(Invocation invocation, ServerNode sourceNode) {
		super(invocation.getObjectId(),invocation.getMethodHash(), invocation.getArgs());
		this.invocation = invocation;
        theNode = sourceNode;
    }

	public synchronized Invocation getInvocation(){
		if(invocation == null){
			invocation = (Invocation)Marshaller.unmarshall(invocationMobj);
		}
		return invocation;
	}

    public void setTargetObject(Object targetObject) {
        throw new IllegalArgumentException("can not setTargetObject in ClusterInvocation.");
    }

	public ServerNode getClusterNode(){
		return theNode;
	}

	private void writeObject(java.io.ObjectOutputStream out)
			throws IOException {
		out.defaultWriteObject();
		out.writeObject(Marshaller.marshall(invocation));
	}

	private void readObject(java.io.ObjectInputStream in)
			throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		invocationMobj = (MarshalledObject)in.readObject();
	}


	public static void main(String[] args) {

    }
}
