/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */

package org.jfox.ioc.connector;

import java.io.Serializable;
import java.rmi.RemoteException;

/**
 * һͨremoteװ clusterable remoteֻһ Serializable ࣬
 * ʵԶ̵
 *
 * Clusterable remoteҪڵóɹ֮״̬ƵȺڵ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ClusterableConnectorRemote extends AbstractConnectorRemote implements ConnectorRemote, Serializable {

    private ConnectorRemote remote;
    private ConnectorRemote[] clusterRemotes;

    public ClusterableConnectorRemote(ConnectorRemote remote, ConnectorRemote[] clusterNodes) {
        this.remote = remote;
	    this.clusterRemotes = clusterNodes;
    }

	/**
	 * ÷ ConnectorInvoker ã÷һлķʵremoteԶ̵õĹ
	 * ڸ÷дFailover״̬
	 *
	 * @param invocation
	 * @return
	 * @throws RemoteException
	 * @throws Exception
	 */
    public Object invoke(Invocation invocation) throws RemoteException, Exception {
		Exception re = null;
		try {
			remote.ping();
		}
		catch(Exception e){ // remote ͨ
			re = e;
			remote = null;
			if(clusterRemotes != null && clusterRemotes.length >0){
				for(int i=0; i<clusterRemotes.length; i++){
					ConnectorRemote _remote = clusterRemotes[i];
						try {
							_remote.ping();
						}
						catch(Exception e1){
							e1.printStackTrace();
							continue;
						}
						remote = _remote;
				}
			}
		}
		if(remote == null){
			throw re;
		}
		invocation.setClustable(true);
        Object result = remote.invoke(invocation);
		return result;
    }

    public void ping() throws RemoteException {
        remote.ping();
    }

    public String getProtocol() throws RemoteException {
        return remote.getProtocol();
    }

	public ConnectorRemote getRemote() {
		return remote;
	}

	/**
	 * Ҫʵʵstart
	 * @throws Exception
	 */
	protected void doStart() throws Exception {
	}

	protected void doStop() throws Exception {
	}

	protected void doInit() throws Exception {
	}

	protected void doDestroy() throws Exception {
	}


	public static void main(String[] args) {

    }
}
