/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */

package org.jfox.ioc.connector;

import java.io.IOException;
import java.io.Serializable;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import org.jfox.ioc.util.Marshaller;

/**
 * ʾǰڵ
 * һJVMУӦΪһ
 * ΪҪͨJGroupлԲܼͨstaticʵֵ
 * ҪʹøöıֱӴServerNode.THE_NODE 
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ServerNode implements Serializable {

	public final static transient ServerNode THE_NODE = new ServerNode();

    /**
     * ýڵ ip ַ
     */
    private String ip;

    /**
     * ýڵĻ
     */
    private String hostName;

    /**
     * ýڵĽĶ˿
     */
    private int port;

	/**
	 * jgroup port
	 */
	private int jgport;

	/**
	 * ڵ protocol=>ConnectorRemoteĶӦ
	 */
	private transient Map<String, ConnectorRemote> connectors = new HashMap<String, ConnectorRemote>();

	public ServerNode() {
	}

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getIp() {
        return ip;
    }

    public void setHostName(String hostName) {
        this.hostName = hostName;
    }

    public String getHostName() {
        return hostName;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public int getPort() {
        return port;
    }

	public int getJgport() {
		return jgport;
	}

	public void setJgport(int jgport) {
		this.jgport = jgport;
	}

	/**
	 *
	 * @param connectors
	 */
	public void setConnectors(Map<String, ConnectorRemote> connectors){
		this.connectors = connectors;
	}

	public ConnectorRemote getConnector(String protocol) {
		return connectors.get(protocol.trim().toUpperCase());
	}

	public String toString() {
		return ip + ":" + port;
	}

	public boolean equals(Object o) {
		if(this == o) return true;
		if(o == null || getClass() != o.getClass()) return false;

		final ServerNode that = (ServerNode) o;

		if(jgport != that.jgport) return false;
		if(port != that.port) return false;
		if(!ip.equals(that.ip)) return false;

		return true;
	}

	public int hashCode() {
		int result;
		result = ip.hashCode();
		result = 29 * result + port;
		result = 29 * result + jgport;
		return result;
	}

	public void registerConnector(String protocol, ConnectorRemote remote) {
//        MarshalledObject mobj = Marshaller.marshall(remote);
		connectors.put(protocol.trim().toUpperCase(), remote);
	}

	public void unregisterConnector(String protocol) {
		connectors.remove(protocol.trim().toUpperCase());
	}

	public Map<String, ConnectorRemote> listConnectors() {
		return Collections.unmodifiableMap(connectors);
	}

	public void removeConnector(String protocol) {
		connectors.remove(protocol);
	}

	public Map<String, ConnectorRemote> getConnectors() {
		return connectors;
	}

	private void writeObject(java.io.ObjectOutputStream out)
			throws IOException {
		out.defaultWriteObject();
		out.writeInt(connectors.size());
		for(Map.Entry<String,ConnectorRemote> entry : connectors.entrySet()){
			out.writeObject(entry.getKey());
			out.writeObject(Marshaller.marshall(entry.getValue()));
		}
	}

	private void readObject(java.io.ObjectInputStream in)
			throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		int size = in.readInt();
		connectors = new HashMap<String,ConnectorRemote>(size);
		while(size-- > 0){
			String key = (String)in.readObject();
			ConnectorRemote remote = (ConnectorRemote)Marshaller.unmarshall(in.readObject());
			connectors.put(key,remote);
		}

	}

	public static void main(String[] args) {

    }
}
