/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.connector.jrmp;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import org.jfox.ioc.connector.AbstractConnectorRemote;
import org.jfox.ioc.connector.ServerNode;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class JRMPConnectorRemote extends AbstractConnectorRemote {

    protected void doInit() throws Exception {
        try {
            UnicastRemoteObject.unexportObject(this, true);
        }
        catch(Exception e) {
            // ignore
        }
    }

    /**
     * export this invoker and set container's invoker to this stub
     *
     * @throws Exception
     */
    protected void doStart() throws Exception {
        UnicastRemoteObject.exportObject(this,getPort());
        // register this Connector
        ServerNode.THE_NODE.registerConnector(getProtocol(),this);

        // һ̣߳ÿһʱ ping һ£ֹ rmi ߳
        Thread pingThread = new Thread(this, getName());
        pingThread.setPriority(Thread.MIN_PRIORITY);
        pingThread.start();
    }

    protected void doStop() throws Exception {
	    ServerNode.THE_NODE.removeConnector(getProtocol());
        UnicastRemoteObject.unexportObject(this, true);
    }

    public String getProtocol() throws RemoteException {
        return "JRMP";
    }

    protected void doDestroy() throws Exception {
	    try {
		    UnicastRemoteObject.unexportObject(this, true);
	    }
	    catch(Exception e) {
		    // ignore
	    }
    }

}
