/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.connector.soap;

import java.rmi.RemoteException;

import org.jfox.ioc.connector.AbstractConnectorRemote;
import org.jfox.ioc.connector.ConnectorRemote;
import org.jfox.ioc.connector.Invocation;
import org.jfox.ioc.connector.ServerNode;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class SOAPConnectorService extends AbstractConnectorRemote implements ConnectorRemote{
	// web server Ļip
	private String httpHost = "localhost";
	// web server  port
	private int httpPort = 8080;
	//  xmlrpc  proxy servletҪ web server ʱ
	private String servletName = "xmlrpc/RPC2";
//  private transient XmlRpcHandler client;
	private SOAPConnectorRemote soapBinder = null;

	public String getProtocol() throws RemoteException {
		return "SOAP";
	}

	public String getHttpHost() {
		return httpHost;
	}

	public int getHttpPort() {
		return httpPort;
	}

	public String getServletName() {
		return servletName;
	}

	public void setHttpHost(String httpHost) {
		this.httpHost = httpHost;
	}

	public void setHttpPort(int httpPort) {
		this.httpPort = httpPort;
	}

	protected void doStart() throws Exception {
		logger.info("soap url: " + getSoapURL());
		ServerNode.THE_NODE.registerConnector(getProtocol(),soapBinder);
	}

	protected void doStop() throws Exception {
		ServerNode.THE_NODE.unregisterConnector(getProtocol());
	}

	protected void doInit() throws Exception {
		soapBinder = new SOAPConnectorRemote(getSoapURL());
	}

	protected void doDestroy() throws Exception {
		soapBinder = null;
	}

	public String getSoapURL() {
		return "http://" + httpHost + ":" + httpPort + "/" + servletName;
	}

	/**
	 * ʵʲõΪͻ˵õ SOAPConnectorRemote
	 *
	 * @param invocation
	 * @return
	 * @throws java.rmi.RemoteException
	 */
	public Object invoke(Invocation invocation) throws RemoteException {
		return soapBinder.invoke(invocation);
/*
    Vector params = new Vector(1);
    params.add(marshelledObject(invocation));
    try {
      // handler Ϊκַ
      return client.execute("xmlrpc",params);
    }
    catch(Exception e) {
      throw new RemoteException(e.getMessage(),e);
    }
*/
	}

	public static void main(String[] args) {

	}

}