/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc.depend;



/**
 * ParameterPack ʾһ setter Ҫ setter ֶƺһ
 *
 * @see Dependency
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class DependencyPack {
    /**
     * ƣ
     */
    private String name;
    /**
     * setter Ĳ
     */
    private Dependency param;
    /**
     * setter
     */
    private String description = "";

    public static DependencyPack[] EMPTY_PARAMETER_PACKS = new DependencyPack[]{};

    public DependencyPack(String name, Dependency param) {
        this(name,param,null);
    }

    public DependencyPack(String name, Dependency param, String description) {
        if(name == null || name.trim().equals("")) {
            throw new IllegalArgumentException("setter name should not be null or empty.");
        }
        this.name = name;
        this.param = param;
        this.description = description;
    }

    /**
     * õ
     */
    public String getName() {
        return "set" + name.substring(0, 1).toUpperCase() + name.substring(1);
    }

    /**
     * õ
     * @return
     */
    public Dependency getParameter() {
        return param;
    }

    /**
     * õ
     * @return
     */
    public String getDescription() {
        if(description == null) {
            description = getName();
        }
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("PropertyParameterPack[");
        if(param != null) sb.append(param.toString());
        sb.append("]");
        return sb.toString();

    }

    public static void main(String[] args) {

    }
}
