/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc.depend;

import org.jfox.ioc.Registry;
import org.jfox.ioc.exception.ComponentException;
import org.jfox.ioc.util.Classes;

/**
 * òͱһʵֱá
 *
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ObjectDependency implements Dependency {

    private String literalValue = null;
    private Object value = null;
    private Class type = null;
    private String stype = null;

    public ObjectDependency(Object obj) {
        this.value = obj;
        this.type = obj.getClass();
    }

    /**
     * type п value ĳ࣬Ҳп type ԭ͡
     *
     * @param value
     * @param type
     */
    public ObjectDependency(Object value, Class type) {
        this.value = value;
        this.type = type;
    }

    public ObjectDependency(String literalValue, String type) {
        this.literalValue = literalValue;
        this.stype = type;
    }

    public ObjectDependency(String literalValue, Class type) {
        this.literalValue = literalValue;
        this.type = type;
    }

   /**
    * ʵ
    */
    public Class getType() {
        return type;
    }

    public String getLiteralValue() {
        if(literalValue == null) {
            literalValue = value.toString();
        }
        return literalValue;

    }

    /**
     *  ObjectParameter ֵ
     *  ObjectParameter  (String literalValue, String type) ģ
     * ᳢װظ࣬ȻһStringĹö
     *
     * װ⣺
     * ǳʽעģʹ ClassLoaderRepository װزͣ
     * ò֮ǰûбLocalClassLoaderװعܳ޷װ⣻
     * ʹòģʹ Module  LocalClassLoader װغò࣬
     * Ȼ(Object value, Class type) ObjectParameter Բڸ⡣
     *
     * @param registry
     * @return
     * @throws org.jfox.ioc.exception.ComponentException
     */
    public Object resolveValue(Registry registry) throws ComponentException {
        if(type == null && stype != null) {
            //ԭ
            if(Classes.isPrimitiveClass(stype)) {
                type = Classes.loadPrimitiveClass(stype);
            }
            else {
                try {
                    // ʹ ClassLoaderRepository װ
                    type = registry.loadClass(stype);
                }
                catch(Exception e) {
                    throw new ComponentException("load type class " + stype + " error", e);
                }
            }
        }
        /**
         * ûֵʹ String Ĺ칹һ
         */
        if(value == null) {
            try {
                value = Classes.newObject(type,literalValue);
                value = type.getConstructor(new Class[]{String.class}).newInstance(new Object[]{literalValue});
            }
            catch(Exception e) {
                throw new ComponentException("resolve component parameter value error", e);
            }
        }
        return value;
    }

    public String toString() {
        return "ComponentInstanceParameter{" +
                "type=" + type +
                ", value=" + (value == null ? "NOT RESOVLED" : value.toString()) +
                "}";
    }

    public static void main(String[] args) {

    }

}

