/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc.ext;

import java.lang.reflect.Method;

/**
 * ɽзصʵָýӿڵִʱ򣬿ڷִǰ󣬽жĲ
 * <br><br>
 * <b>ע⣺</b>ùͨJava̬ʵ֣ԣΪʹøùܣȶComponentĽӿڣ
 * صComponentʵҲֻͳɽӿͣ磺
 * <pre>
 *      public interface TestComponentInterface extends Component{
 *          public String getName();
 *      }
 *
 *      public class TestComponent implements TestComponentInterface, InterceptableComponent {
 *          public String getName() {
 *              return "getName body";
 *          }
 *          public void preInvoke(Method method, Object[] params){
 *              if(method.getName().equals("getName")) {
 *                  System.out.println("preInvoke " + method.getName());
 *              }
 *          }
 *          public void postInvoke(Method method, Object result){
 *              if(method.getName().equals("getName")) {
 *                  System.out.println("postInvoke " + method.getName());
 *              }
 *              return result;
 *          }
 *      }
 *
 *      Registry registry = Registry.getInstance();
 *      registry.registerComponent(TestComponent.class);
 *      TestComponentInterface tc = (TestComponentInterface)registry.getFirstComponentMetabyImplemetation(TestComponent.class);
 *      system.out.println(tc.getName());
 *      ...
 *
 *      ִн:
 *      preInvoke getName
 *      getName body
 *      postInvoke getName
 *
 * </pre>
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public interface InterceptableComponent extends InstantiatedComponent {

    /**
     * do something before invoke a method defined in component interface
     * example: want to log, or repack the params
     *
     * @param method
     * @param params
     */
    void preInvoke(Method method, Object[] params);

    /**
     * do something after invoke a method
     * example: want to repack the result
     *
     * @param method
     * @param result result return by the method
     * @return the last object return, may not be the result parameter
     */
    Object postInvoke(Method method, Object result);

}