/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.factory;

import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentName;
import org.jfox.ioc.Registry;
import org.jfox.ioc.depend.Dependency;
import org.jfox.ioc.exception.ComponentException;


/**
 * ʵĹ
 * <br>
 * ͨRegistryȡʵʱRegistryøĹʵ
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public abstract class ComponentFactory {

    /**
     * һʵ
     *
     * @return Component instance
     */
    public abstract Component makeComponent() throws ComponentException;

    /**
     * ע
     * @return
     */
    public abstract ComponentName getComponentName();

    /**
     *  Class
     */
    public abstract Class getImplementation();

    /**
     * ʱڹĲ
     */
    public abstract Dependency[] getParameters();

    /**
     * Registry
     */
    public abstract Registry getRegistry();

    /**
     * ڵRegistryһ㲻ûֶã
     * ڽעᵽRegistryʱRegistryԶص÷
     * @param registry
     */
    public abstract void setRegistry(Registry registry);

    /**
     * ṩĲ飬ָʵ
     * @param params ò
     * @return ʵ
     * @throws org.jfox.ioc.exception.ComponentException
     */
    protected Object[] resolveParameters(Dependency[] params) throws ComponentException {
        if(params == null || params.length == 0) {
            return new Object[]{};
        }
        else {
            Object[] objs = new Object[params.length];
            for(int i = 0; i < params.length; i++) {
                objs[i] = params[i].resolveValue(getRegistry());
            }
            return objs;
        }
    }

    /**
     * ṩĲ飬õִе
     * @param params
     * @return
     */
    protected Class[] getParameterTypes(Dependency[] params) {
        if(params == null) {
            return new Class[]{};
        }
        else {
            Class[] types = new Class[params.length];
            for(int i = 0; i < params.length; i++) {
                types[i] = params[i].getType();
            }
            return types;
        }
    }

}