/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.factory;

import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentName;
import org.jfox.ioc.Registry;
import org.jfox.ioc.depend.Dependency;
import org.jfox.ioc.exception.ComponentException;

/**
 * FactoryװĬϲеĲʵʵFactory
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public abstract class DecorateComponentFactory extends ComponentFactory {
    protected ComponentFactory delegate;

    public DecorateComponentFactory(ComponentFactory delegate) {
        this.delegate = delegate;
    }

    public Component makeComponent() throws ComponentException {
        return delegate.makeComponent();
    }

    public ComponentName getComponentName() {
        return delegate.getComponentName();
    }

    public Class getImplementation() {
        return delegate.getImplementation();
    }

    public Dependency[] getParameters() {
        return delegate.getParameters();
    }

    public Registry getRegistry() {
        return delegate.getRegistry();
    }

    public void setRegistry(Registry registry) {
        delegate.setRegistry(registry);
    }

    public static void main(String[] args) {

    }

}

