/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */
package org.jfox.ioc.factory;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;

import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentContext;
import org.jfox.ioc.depend.Dependency;
import org.jfox.ioc.depend.DependencyPack;
import org.jfox.ioc.exception.ComponentException;
import org.jfox.ioc.util.Classes;

/**
 * עʹõFactory
 * <br>
 * ùڹʵ֮󣬻Setterָķ
 * ͨsetterעĹ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class PropertyComponentFactory extends DecorateComponentFactory {
    private DependencyPack[] paramPacks;

    /**
     * 洢 getComponentInstance ʱ ParameterPack[]
     */
    private DependencyPack[] tempParamPacks = DependencyPack.EMPTY_PARAMETER_PACKS;

    public PropertyComponentFactory(ConstrComponentFactory delegate, DependencyPack[] propParamPacks) {
        super(delegate);
        this.paramPacks = propParamPacks;
    }

    /**
     * ʵȻ setter
     */
    public synchronized Component makeComponent() throws ComponentException {
        Component component = super.makeComponent();
        doMethods(component);
        return component;
    }

    /**
     * makeComponent ֮ComponentContextٷ setter method
     * @param context
     * @return
     * @throws ComponentException
     */
    public synchronized Component makeComponent(ComponentContext context) throws ComponentException {
        Component component = super.makeComponent();
        component.setComponentContext(context);
        doMethods(component);
        return component;
    }

    /**
     * õ Setter 
     */
    public DependencyPack[] getParameterPacks() {
        return paramPacks;
    }

    /**
     * ׷ ParameterPack getComponentInstance 
     *
     * @param propParamPacks
     */
    public void addParameterPack(DependencyPack[] propParamPacks) {
        if(propParamPacks != null && propParamPacks.length != 0) {
            tempParamPacks = propParamPacks;
        }
    }

    /**
     * е Setter
     *
     * @param component
     * @throws ComponentException
     */
    private void doMethods(Component component) throws ComponentException {
        if(paramPacks == null || paramPacks.length == 0) return;
        for(int i = 0; i < paramPacks.length; i++) {
            DependencyPack pack = paramPacks[i];
            doMethod(component, pack);
        }

        if(tempParamPacks != null && tempParamPacks.length != 0) {
            try {

                for(int i = 0; i < tempParamPacks.length; i++) {
                    DependencyPack pack = tempParamPacks[i];
                    doMethod(component, pack);
                }

            }
            finally {
                tempParamPacks = DependencyPack.EMPTY_PARAMETER_PACKS;
            }
        }
    }

    /**
     * ʹ÷һ Setter
     */
    protected void doMethod(Component component, DependencyPack pack) throws ComponentException {
        Object[] params = resolveParameters(new Dependency[]{pack.getParameter()});
        Class[] types = getParameterTypes(new Dependency[]{pack.getParameter()});


        Method method = null;
        try {
            method = Classes.getMethod(component.getClass(), pack.getName(), types);
        }
        catch(Exception e) {
            throw new ComponentException("get method " + pack.getName() + Arrays.asList(types) + " error", e);
        }
        try {
            method.invoke(component, params);
        }
        catch(InvocationTargetException e) {
            throw new ComponentException("do method " + pack.getName() + " error", e.getTargetException());
        }
        catch(Exception e) {
            throw new ComponentException("do method " + pack.getName() + " error", e);
        }
    }

    public static void main(String[] args) {

    }
}

