/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */

package org.jfox.ioc.integration;

import java.io.File;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.jfox.ioc.common.AbstractService;
import org.jfox.ioc.ext.ActiveComponent;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class IntegrateService extends AbstractService implements ActiveComponent {

    private ProcessBuilder pbuilder = null;
    private Process process = null;

    private String workDirectory = ".";
    private String startCmd = "";
    private String stopCmd = "";

    public String getWorkDirectory() {
        return workDirectory;
    }

    public void setWorkDirectory(String workDirectory) {
        this.workDirectory = context.getModuleDir() + "/" + workDirectory;
    }

    public String getStartCmd() {
        return startCmd;
    }

    public void setStartCmd(String startCmd) {
        this.startCmd = startCmd;
    }

    public String getStopCmd() {
        return stopCmd;
    }

    public void setStopCmd(String stopCmd) {
        this.stopCmd = stopCmd;
    }

    protected void doStart() throws Exception {
        Thread thread = new Thread(this);
        thread.setPriority(Thread.MIN_PRIORITY);
        thread.start();
    }

    protected void doStop() throws Exception {
        logger.debug("stop command: cmd /c " + getStopCmd());
        if(stopCmd != null) {
            Process proc = new ProcessBuilder("cmd", "/c", getStopCmd()).directory(new File(getWorkDirectory())).start();
            BufferedReader br = new BufferedReader(new InputStreamReader(proc.getErrorStream()));
            String line = null;
            while((line = br.readLine()) != null) {
                logger.debug(line);
            }
        }
//        process.destroy();
    }

    protected void doInit() throws Exception {
    }

    protected void doDestroy() throws Exception {
    }

    public void run() {
        try {
            logger.debug("start command: cmd /c " + getStartCmd());
            pbuilder = new ProcessBuilder("cmd", "/c", getStartCmd());
            pbuilder = pbuilder.directory(new File(getWorkDirectory()));
            process = pbuilder.start();
            BufferedReader br = new BufferedReader(new InputStreamReader(process.getErrorStream()));
            String line = null;
            while((line = br.readLine()) != null) {
                logger.debug(line);
            }
        }
        catch(Exception e) {
            logger.warn("start error.", e);
        }

    }

    public static void main(String[] args) throws Exception {
        IntegrateService iservice = new IntegrateService();
        iservice.setStartCmd("mysqld --standalone");
        iservice.setWorkDirectory("plugins/ebseries/mysql/bin");
        iservice.init();
        iservice.start();
    }
}
