package org.jfox.ioc.util;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class Annotations {

    /**
     * method Ƿ annotation ע
     */
    public static boolean isAnnotated(Method method, Class<? extends Annotation> annotation) {
        return method.isAnnotationPresent(annotation);
    }

    public static Method[] getAnnotatedMethods(Class clz, Class<? extends Annotation> annotation){
        List<Method> methods = new ArrayList<Method>();
        Method[] allMethods = clz.getMethods();
        for(int i=0; i<allMethods.length; i++) {
            if(isAnnotated(allMethods[i], annotation)) {
                methods.add(allMethods[i]);
            }
        }
        return methods.toArray(new Method[methods.size()]);
    }

    public static Method[] getAnnotatedSetMethods(Class clz, Class<? extends Annotation> annotation){
        List<Method> methods = new ArrayList<Method>();
        Method[] allMethods = clz.getMethods();
        for(int i=0; i<allMethods.length; i++) {
            if(Methods.isSetMethod(allMethods[i]) && isAnnotated(allMethods[i], annotation)) {
                methods.add(allMethods[i]);
            }
        }
        return methods.toArray(new Method[methods.size()]);
    }

    public static Method[] getAnnotatedGetMethods(Class clz, Class<? extends Annotation> annotation){
        List<Method> methods = new ArrayList<Method>();
        Method[] allMethods = clz.getMethods();
        for(int i=0; i<allMethods.length; i++) {
            if(Methods.isGetMethod(allMethods[i]) && isAnnotated(allMethods[i], annotation)) {
                methods.add(allMethods[i]);
            }
        }
        return methods.toArray(new Method[methods.size()]);
    }

    public static boolean hasAnnotatedMethod(Class clz, Class<? extends Annotation> annotation){
        Method[] allMethods = clz.getMethods();
        for(int i=0; i<allMethods.length; i++) {
            if(isAnnotated(allMethods[i], annotation)) {
               return true;
            }
        }
        return false;
    }

	public static boolean isAnnotated(Field field,
	                                  Class<? extends Annotation> annotation) {
		return field.isAnnotationPresent(annotation);
	}

	public static void main(String[] args) {

    }
}

