/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.ioc.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class DTDEntityResolver implements EntityResolver {
    // public id -> local dtd name
    private static Properties pubToLocal = new Properties();
    private final static String DTD_PROPERTIES = "dtd.properties";
    private final static ClassLoader cl = Thread.currentThread().getContextClassLoader(); 
    
    static {
        InputStream fin = null;
        try {
            fin = cl.getResourceAsStream(DTD_PROPERTIES); //new FileInputStream(DTD_PATH + "dtd.properties");
            pubToLocal.load(fin);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        finally {
            if(fin != null) {
                try {
                    fin.close();
                }
                catch(Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }


    public InputSource resolveEntity(String publicId, String systemId) throws SAXException, IOException {
        if(publicId == null) return null;
        // let it be
        if(!pubToLocal.containsKey(publicId)) return null;

        String dtd = pubToLocal.getProperty(publicId);
        try {
//            FileInputStream dtdStream = new FileInputStream(DTD_PATH + dtd);
            InputSource inputSource = new InputSource(cl.getResourceAsStream(dtd));
            return inputSource;
        }
        catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void main(String[] args) {

    }
}



