/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.component;

import java.lang.reflect.Method;

import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentContext;
import org.jfox.ioc.ext.InterceptableComponent;

/**
 * Test component interceptable and injection constructor
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class TestComponentB implements InterceptableComponent, TestComponent {
    private String name = "Hello,World!";

    private ComponentContext ctx;

    public TestComponentB() {
    }

    public TestComponentB(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void preInvoke(Method method, Object[] params) {
        System.out.println("preInvoke: " + method.getName());
    }

    public Object postInvoke(Method method, Object result) {
        System.out.println("postInvoke: " + method.getName());
        return result;
    }

    public String getComponentDir(){
        return ctx.getModuleDir();
    }

    public void setComponentContext(ComponentContext ctx) {
        this.ctx = ctx;
    }


    public Component afterInstantiate(Component component) {
        System.out.println("afterInstantiate: Component " + this + " created.");
        return component;
    }

    public static void main(String[] args) {

    }
}

