package org.jfox.ioc.util;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.reflect.Method;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class AnnotationsTest extends TestCase{
    protected void setUp() throws Exception {
        super.setUp();
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void testIsAnnoated(){
        Method method = null;
        try {
            method = TestClass.class.getMethod("testMethod",new Class[]{});
        }
        catch(Exception e){
            e.printStackTrace();
            assertTrue(false);
        }
        System.out.println(method.getAnnotations().length);
        assertTrue(Annotations.isAnnotated(method, MyAnnotation.class));

    }
}

@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
@interface MyAnnotation {

}

class TestClass {

    @MyAnnotation
    public void testMethod(){

    }

}

