/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.xml;

import java.io.File;

import junit.framework.TestCase;
import org.jfox.ioc.deploy.ComponentDescriptor;
import org.jfox.ioc.deploy.ComponentModuleDescriptor;
import org.jfox.ioc.util.XMLUtils;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ComponentBundleTest extends TestCase {
    ComponentModuleDescriptor componentModuleDescriptor;

    public void setUp() throws Exception {
        super.setUp();
        componentModuleDescriptor = new ComponentModuleDescriptor(XMLUtils.getDocument(new File("modules/SampleA/META-INF/module.xml").toURL()));
    }

    public void tearDown() throws Exception {
        super.setUp();
    }

    public void testCount() {
        ComponentDescriptor[] cds = componentModuleDescriptor.getComponentDescriptors();
        assertEquals(1, cds.length);
    }

    public void testComponentDescriptor() {
        ComponentDescriptor cd = componentModuleDescriptor.getComponentDescriptors()[0];
        assertEquals(cd.getImplementation(), "org.jfox.ioc.TestComponentA");
    }

}