/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.sample;

import java.lang.reflect.Method;

import org.jfox.ioc.Component;
import org.jfox.ioc.ComponentContext;
import org.jfox.ioc.ext.InterceptableComponent;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class SampleComponentA implements Component, InterceptableComponent, SampleComponent {
    private String name = "Hello,World";

    public SampleComponentA() {
    }

    public SampleComponentA(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setComponent(Component tc) {

    }

    public void preInvoke(Method method, Object[] params) {
        if(!method.getName().equals("toString")){
            System.out.println("Intercepter: preInvoke "+ this.getClass().getName() + "." + method.getName());
        }
    }

    public Object postInvoke(Method method, Object result) {
        if(!method.getName().equals("toString")){
            System.out.println("Intercepter: postInvoke " + this.getClass().getName() + "." + method.getName());
        }
        return result;
    }

    public void setComponentContext(ComponentContext ctx) {

    }

    public Component afterInstantiate(Component component) {
        System.out.println("Intercepter: Component " + this.getClass().getName() + " instantiated.");
        return component;
    }


    public static void main(String[] args) {

    }
}

