/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ioc.sample;

import org.jfox.ioc.ComponentContext;
import org.jfox.ioc.annotation.Managable;
import org.jfox.ioc.ext.ActiveComponent;
import org.jfox.ioc.ext.ManagableComponent;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class SampleComponentC implements ManagableComponent, ActiveComponent {

    private int id = 0;
    private String name = "Hello,World from SampleComponentC";
    private Long time = new Long(System.currentTimeMillis());

    private ComponentContext ctx;

    @Managable
    public void setName(String name) {
        this.name = name;
    }

    @Managable
    public String getName() {
        return name;
    }

    @Managable
    public int getId() {
        return id;
    }

    @Managable
    public void setId(int id) {
        this.id = id;
    }

    @Managable
    public void setTime(Long time) {
        this.time = time;
    }

    @Managable
    public Long getTime() {
        return time;
    }

    public void setComponentContext(ComponentContext ctx) {
        this.ctx = ctx;
    }

    @Managable
    public String getComponentDir(){
        return ctx.getModuleDir();
    }

    public static void main(String[] args) {

    }

}

