/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.deployment.web;

import javax.naming.Context;

import org.jfox.ioc.Registry;
import org.jfox.ioc.exception.ComponentException;
import org.jfox.jndi.enc.AbstractEnterpriseContextContainer;
import org.jfox.jndi.enc.EnterpriseContext;
import org.jfox.jndi.enc.EnterpriseContextInvocationHandler;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class WebEnterpriseContextContainer extends AbstractEnterpriseContextContainer {
    private static WebEnterpriseContextContainer instance = new WebEnterpriseContextContainer();

    private WebDeployer webDeployer = null;

    public WebEnterpriseContextContainer() {
        try {
            webDeployer = (WebDeployer)(Registry.getInstance().getComponentInstance(WebDeployer.class));
        }
        catch(ComponentException e) {
            e.printStackTrace();
            throw new RuntimeException("Web container instance error");
        }
    }

    public static WebEnterpriseContextContainer getInstance() {
        return instance;
    }


    public Context getCurrentEnterpriseContext() {
        String webContext = (String) currName.get();
        if(webContext == null) {
            return new EnterpriseContext();
        }
        return ((NestedWebModule) webDeployer.getWebModule(webContext)).getEnterpriseContext();
    }

    public EnterpriseContextInvocationHandler getEnterpriseContextInvocationHandler() {
        return new EnterpriseContextInvocationHandler(getCurrentEnterpriseContext());
    }

    public static void main(String[] args) {

    }
}
