/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ejb;

import java.lang.reflect.Method;
import javax.ejb.TimerService;

import org.jfox.ejb.connector.EJBInvocation;
import org.jfox.ejb.handler.HandlerChain;
import org.jfox.ejb.meta.EJBDescriptor;
import org.jfox.ioc.Component;
import org.jfox.ioc.ext.InitializableComponent;
import org.jfox.jndi.enc.EnterpriseContext;

/**
 * a bucket һض bean bean һԴbucket  container 
 * <p/>
 * ̳ EJBOperation ΪǿʵķԱڷʱֱӵ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public interface Bucket extends EJBOperation, Component, InitializableComponent {

    /**
     * invoke a method
     * @return
     */
//  Object invoke(Invocation invocation) throws Exception;

    /**
     * õ ejb  classLoader
     */
    ClassLoader getEJBClassLoader();

    Method getHomeMethod(EJBInvocation invocation) throws NoSuchMethodException;

    Method getBeanMethod(EJBInvocation invocation) throws NoSuchMethodException;

    /**
     *  EJBHome ķ
     *
     * @param invocation
     * @return Bean  ObjectId
     * @throws Exception
     */
    Object invokeHome(EJBInvocation invocation) throws Exception;

    /**
     * ִ Bean ķ
     *
     * @param invocation
     * @return
     * @throws Exception
     */
    Object invokeBean(EJBInvocation invocation) throws Exception;

    EJBDescriptor getEJBDescriptor();

    EnterpriseContext getEnterpriseContext();

    TimerService getTimerService();

    EJBObjectId nextObjectId();

    EJBObjectId getHomeObjectId();

    Class getBeanClass();

    void setBucketMeta(BucketMeta meta);

    void setHandlerChain(HandlerChain handlerChain);

    EJBPoolableObject retrieveBean(Object key) throws Exception;

    void restoreBean(Object key, EJBPoolableObject pobj);

    /**
     *  home.create ʱʹø÷Beanʵ
     * @param invocation
     * @return
     * @throws Exception
     */
    EJBObjectId createBean(EJBInvocation invocation) throws Exception;

	/**
	 * Ⱥͬ
	 */
	void syncBean(EJBInvocation invocation);


}