/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ejb;

import javax.ejb.EnterpriseBean;

import org.jfox.pool.PoolableObject;
import org.jfox.pool.SimpleObjectFactory;


/**
 *  EJBPoolableObject , EJBPoolableObject װ EJBObject
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class EJBObjectFactory extends SimpleObjectFactory {

    // EJB bean class
    private Bucket bucket = null;

    /**
     *
     * @param classType EJBPoolableObject.class
     * @param bucket
     * @throws Exception
     */
    public EJBObjectFactory(Class classType, Bucket bucket) throws Exception {
        super(classType);
        this.bucket = bucket;
    }

    public PoolableObject makeObject() throws Exception {
        EJBPoolableObject pobj = (EJBPoolableObject) super.makeObject();
        EnterpriseBean bean = (EnterpriseBean) bucket.getBeanClass().newInstance();
        pobj.setBeanInstance(bean);
        return pobj;
    }

    public Bucket getBucket() {
        return bucket;
    }

    public static void main(String[] args) {

    }
}
