/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ejb;

import java.io.Serializable;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.jms.JMSException;
import javax.jms.Session;

import org.jfox.jms.JMSConnection;
import org.jfox.jms.connector.JMSContainer;
import org.jfox.jms.message.JMSMessage;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class MDBConnection extends JMSConnection implements Serializable {

    public MDBConnection(String clientId, JMSContainer container, boolean isXA) {
        super(clientId, container, isXA);
    }

    /**
     * create MDBSession
     *
     * @param transacted
     * @param acknowledgeMode
     * @return
     * @throws javax.jms.JMSException
     */
    public synchronized Session createSession(boolean transacted, int acknowledgeMode) throws JMSException {
        checkClosed();
        if(transacted) {
            acknowledgeMode = Session.SESSION_TRANSACTED;
        }
        MDBSession session = new MDBSession(this, transacted, acknowledgeMode, false);
        container.registerSession(clientId, session.getSessionId());
        synchronized(sessions) {
            sessions.put(session.getSessionId(), session);
        }
        return session;
    }

    /**
     * MDB ʹøonMessageΪ MDB ʵѾȡ
     *
     * @param sessionId
     * @param consumerId
     * @param msg
     * @throws java.rmi.RemoteException
     * @throws JMSException
     */
    public void onMessage(String sessionId, String consumerId, JMSMessage msg) throws RemoteException, JMSException {
        throw new EJBException("invalid onMessage call in MessageDrivenBean.");
    }

    public void onMessage(String sessionId, MessageDrivenBean bean, JMSMessage msg) throws RemoteException, JMSException {
        MDBSession session = (MDBSession) sessions.get(sessionId);
        session.onMessage(bean, msg);
    }

}