/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.ejb;

import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.jms.JMSException;
import javax.jms.MessageListener;

import org.jfox.jms.JMSConnection;
import org.jfox.jms.JMSConsumer;
import org.jfox.jms.JMSSession;
import org.jfox.jms.message.JMSMessage;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class MDBSession extends JMSSession {
    public MDBSession(JMSConnection conn, boolean transacted, int acknowledgeMode, boolean isXA) {
        super(conn, transacted, acknowledgeMode, isXA);
    }

    /**
     * ̼߳Ϣ
     */
    protected void start() {

    }

    public void run() {
//        super.run();
    }

    protected String getSessionId() {
        return super.getSessionId();
    }

    /**
     * MDB ʹøonMessageΪ MDB ʵѾȡ
     *
     * @param consumerId
     * @param message
     */
    protected void onMessage(String consumerId, JMSMessage message) {
        throw new EJBException("invalid onMessage call in MessageDrivenBean.");
    }

    /**
     * @param bean    ִϢMDB InstancePoolHandler ȡ
     * @param message
     */
    protected void onMessage(MessageDrivenBean bean, JMSMessage message) {
        if(!(bean instanceof MessageListener)) {
            throw new EJBException("MessageDrivenBean " + bean + " not implements " + MessageListener.class.getName());
        }
        ((MessageListener) bean).onMessage(message);
    }

    public void acknowledge(JMSConsumer consumer, JMSMessage message) throws JMSException {
        super.acknowledge(consumer, message);
    }

    protected synchronized void setConsumerAsync(JMSConsumer consumer, boolean async) throws JMSException {
        super.setConsumerAsync(consumer, async);
    }

}

