/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */

package org.jfox.ejb.connector;

import org.jfox.ioc.connector.AbstractHandler;
import org.jfox.ioc.connector.Container;
import org.jfox.ioc.connector.Invocation;

/**
 * ִ EJB 
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class EJBHandler extends AbstractHandler {

    public EJBHandler(Container container) {
        super(container);
    }

    public Class getInvocationClass() {
        return EJBInvocation.class;
    }

    public Object execute(Invocation invocation) throws Throwable {
        if(!isInitialized()) {
            throw new Exception("Handler not started.");
        }
        ClassLoader oldCl = Thread.currentThread().getContextClassLoader();
        /**
         * Ҫó Module  LocalClassLoader
         *  Module ûԤصҲ
         */
        ClassLoader cl = this.getClass().getClassLoader();
        Thread.currentThread().setContextClassLoader(cl);
        try {
            return doExecute(invocation);
        }
        finally {
            Thread.currentThread().setContextClassLoader(oldCl);
        }

    }

    /**
     * EJBContainerø÷
     * @param invocation
     * @return
     * @throws Throwable
     */
    protected Object doExecute(Invocation invocation) throws Throwable {
/*
        EJBObjectId ejbObjectId = (EJBObjectId) invocation.getObjectId();
        String ejbName = ejbObjectId.getEjbName();
        Bucket bucket = ((EJBContainer)getContainer()).getBucket(ejbName);
        if(bucket instanceof StatefulBucket){
            
        }
*/
        return ((EJBContainer)getContainer()).invoke((EJBInvocation)invocation);
    }

    public static void main(String[] args) {

    }
}
