/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */

package org.jfox.ejb.handler;

import java.lang.reflect.Method;
import java.util.Iterator;
import javax.ejb.EJBException;
import javax.ejb.EnterpriseBean;
import javax.ejb.MessageDrivenBean;

import org.jfox.ejb.Bucket;
import org.jfox.ejb.MDBBucket;
import org.jfox.ejb.connector.EJBInvocation;
import org.jfox.jms.message.JMSMessage;

/**
 * һһ invoker
 * invokeHome:  EJBObject  invoker
 * invokeBean: ִʵʵķ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class Z5_MDBHandler extends AbstractHandler {

    public Object invokeHome(Bucket bucket, EJBInvocation invocation, Iterator iter) throws Exception {
        throw new EJBException("MessageDrivenBean has no EJBHome.");
    }

    public Object invokeBean(Bucket bucket, EJBInvocation invocation, Iterator iter) throws Exception {
        Method method = invocation.getMethod();
        EnterpriseBean bean = invocation.getBean();
        if(method.getName().equals("onMessage")) {
            Object[] args = invocation.getArgs();
            String sessionId = (String)args[0];
            JMSMessage msg = (JMSMessage)args[2];
            ((MDBBucket)bucket).onMessage(sessionId,(MessageDrivenBean)bean,msg);
            return null;
        }
        else {
            return method.invoke(bean, invocation.getArgs());
        }
    }

    public static void main(String[] args) {

    }
}  
