package org.jfox.ejb.timer;

import javax.ejb.EJBException;
import javax.ejb.NoSuchObjectLocalException;
import javax.ejb.Timer;
import javax.ejb.TimerHandle;

import org.jfox.ejb.connector.EJBContainerImpl;
import org.jfox.ioc.ComponentName;
import org.jfox.ioc.Registry;
import org.jfox.ioc.connector.Container;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class EJBTimerHandler implements TimerHandle {
    private String ejbName;
    private String identity;

    public EJBTimerHandler(String ejbName, String identity) {
        this.ejbName = ejbName;
        this.identity = identity;
    }

    /**
     * @return
     * @throws IllegalStateException
     * @throws NoSuchObjectLocalException
     * @throws EJBException
     */
    public Timer getTimer() throws IllegalStateException, NoSuchObjectLocalException, EJBException {
        try {
        EJBTimerService timerService = (EJBTimerService) ((EJBContainerImpl) Registry.getInstance().getComponentInstance(ComponentName.parseString(Container.class.getName() + "@EJB"))).getBucket(ejbName).getTimerService();
        return timerService.getTimer(identity);
        }
        catch(Exception e){
            e.printStackTrace();
            return null;
        }
    }


    public String toString() {
        return "EJBTimerHandler{" +
                "ejbName='" + ejbName + "'" +
                ", identity='" + identity + "'" +
                "}";
    }

    public static void main(String[] args) {

    }
}

