/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.jetty.cluster;

import java.lang.reflect.Method;

import org.jfox.ioc.connector.ClusterInvocation;
import org.jfox.ioc.connector.ClusterServer;
import org.jfox.ioc.connector.ClusterableContainer;
import org.jfox.ioc.connector.ConnectorServer;
import org.jfox.ioc.connector.Container;
import org.jfox.ioc.connector.Handler;
import org.jfox.ioc.connector.Invocation;
import org.jfox.ioc.connector.ServerNode;
import org.jfox.ioc.logger.Logger;
import org.mortbay.j2ee.session.AbstractReplicatedStore;

/**
 * ʹClusterServerͺͽSessionϢ
 * ClusterStore Ϊ Session
 * <p/>
 * ҪҪ publishClusterServer.castϢ
 *
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ClusterStore extends AbstractReplicatedStore implements ClusterableContainer, Handler {
    protected Logger _log = Logger.getLogger(ClusterStore.class);

    public ClusterStore() {
        super();
    }

    public void start() throws Exception {
        super.start();
    }

    public void stop() {
        super.stop();
    }

    public void destroy() {
        super.destroy();
    }

    protected void publish(String id, Method method, Object[] argInstances) {
        HttpSessionInvocation invocation = new HttpSessionInvocation(null, null, argInstances);
        invocation.setSessionId(id);
        invocation.setMethodId((Integer) _methodToInteger.get(method));
        // ʹ ClusterServer cast invocation
        ClusterInvocation clusterInvocation = new ClusterInvocation(invocation, ServerNode.THE_NODE);
        ClusterServer clusterServer = ConnectorServer.getClusterServer();
        if (clusterServer != null) { // clusterServer 
            try {
                clusterServer.cast(clusterInvocation);
            }
            catch (Exception e) {
                _log.warn("session publish failed.", e);
            }
        }

    }

    /**
     *  Session ͬ
     *
     * @param invocation
     */
    public void syncInvocation(Invocation invocation) {
        HttpSessionInvocation sessionInvocation = (HttpSessionInvocation) invocation;
        String id = sessionInvocation.getSessionId();
        Integer method = sessionInvocation.getMethodId();
        Object[] args = sessionInvocation.getArgs();
        //TODO:ʹdispatchַϢ
//        dispatch(id,method,args);
    }

    public Class getHandlerClass() {
        return this.getClass();
    }

    public Class getInvocationClass() {
        return HttpSessionInvocation.class;
    }

    public Container getContainer() {
        return this;
    }

    /**
     * ֱӵ syncInvocation
     *
     * @param invocation
     * @return
     * @throws Throwable
     */
    public Object execute(Invocation invocation) throws Throwable {
        syncInvocation(invocation);
        return null;
    }

    /**
     * õ
     *
     * @param hashId
     */
    public Method getMethodByHash(String hashId) {
        return null;
    }

    public static void main(String[] args) {

    }
}
