/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms.server;

import javax.naming.Context;

import org.jfox.ioc.common.AbstractService;
import org.jfox.ioc.ext.ActiveComponent;
import org.jfox.jndi.InitialContextHelper;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSConnectionFactoryS extends AbstractService implements ActiveComponent {

	private String jndiName = "jms/defaultcf";

	public JMSConnectionFactoryS(String jndiName) {
		this.jndiName = jndiName;
	}

	protected void doStart() throws Exception {
        this.getClass().getClassLoader().loadClass("org.jfox.jndi.InitialContextHelper");
		Context ctx = InitialContextHelper.getInitialContext();
		logger.info("bind ConnectionFactory " + jndiName);
		ctx.bind(jndiName, new org.jfox.jms.JMSConnectionFactory());

	}

	protected void doStop() throws Exception {
		logger.info("unbind ConnectionFactory " + jndiName);
		Context ctx = InitialContextHelper.getInitialContext();
		ctx.unbind(jndiName);
	}

	protected void doInit() throws Exception {
	}

	protected void doDestroy() throws Exception {
	}

	public void run() {
	}


	public static void main(String[] args) {

	}
}

