/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms.server;

import javax.jms.Queue;

import org.jfox.ioc.common.AbstractService;
import org.jfox.ioc.ext.ActiveComponent;
import org.jfox.jms.JMSQueue;
import org.jfox.jms.connector.JMSDestinations;
import org.jfox.jndi.InitialContextHelper;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSQueueS extends AbstractService implements ActiveComponent {

	private String queueName;
	private String queueJndiName;
	private Queue queue;

	public JMSQueueS() {
	}

	protected void doInit() throws Exception {
	}

	protected void doDestroy() throws Exception {

	}

	protected void doStart() throws Exception {
		logger.debug("bind queue: " + queueJndiName);
		InitialContextHelper.getInitialContext().rebind(queueJndiName, queue);
		JMSDestinations.getInstance().registerDestination(queue);
	}

	protected void doStop() throws Exception {
		logger.debug("unbind queue: " + queueJndiName);
		InitialContextHelper.getInitialContext().unbind(queueJndiName);
		JMSDestinations.getInstance().unregisterDestination(queue);
	}

	public void run() {
	}

    public void setQueueName(String queueName) {
        this.queueName = queueName;
        queue = new JMSQueue(queueName);
    }

    public void setQueueJndiName(String queueJndiName) {
        this.queueJndiName = queueJndiName;
    }

	public String getQueueName() {
		return queueName;
	}

	public String getQueueJndiName() {
		return queueJndiName;
	}

	public static void main(String[] args) {

	}
}

