/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms.server;

import javax.jms.Topic;

import org.jfox.ioc.common.AbstractService;
import org.jfox.ioc.ext.ActiveComponent;
import org.jfox.jms.JMSTopic;
import org.jfox.jms.connector.JMSDestinations;
import org.jfox.jndi.InitialContextHelper;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSTopicS extends AbstractService implements ActiveComponent {

	private Topic topic;
	private String topicJndiName;
	private String topicName;

	public JMSTopicS() {

	}

	protected void doInit() throws Exception {

	}

	protected void doDestroy() throws Exception {

	}

	protected void doStart() throws Exception {
		logger.debug("bind topic: " + topicJndiName);
		InitialContextHelper.getInitialContext().rebind(topicJndiName, topic);
		JMSDestinations.getInstance().registerDestination(topic);
	}

	protected void doStop() throws Exception {
		logger.debug("unbind topic: " + topicJndiName);
		InitialContextHelper.getInitialContext().unbind(topicJndiName);
		JMSDestinations.getInstance().unregisterDestination(topic);
	}

	public void run() {
	}

    public void setTopicJndiName(String topicJndiName) {
        this.topicJndiName = topicJndiName;
    }

    public void setTopicName(String topicName) {
        this.topicName = topicName;
        topic = new JMSTopic(topicName);
    }

	public String getTopicName() {
		return topicName;
	}

	public String getTopicJndiName() {
		return topicJndiName;
	}


	public static void main(String[] args) {

	}
}

