/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms;

import javax.jms.Connection;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.QueueReceiver;
import javax.jms.Session;
import javax.naming.InitialContext;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSAsyncConsumerTest{
    JMSConnectionFactory jmsConnectionFactory;
    Connection conn;
    Session session;
    Queue queue;
    QueueReceiver queueReceiver;



    public void setUp() throws Exception {
        InitialContext ctx = new InitialContext();
        Object cf = ctx.lookup("jms/defaultcf");
        jmsConnectionFactory = (JMSConnectionFactory) javax.rmi.PortableRemoteObject.narrow(cf, JMSConnectionFactory.class);
        queue = (Queue)javax.rmi.PortableRemoteObject.narrow(ctx.lookup("jms/defaultQ1"),Queue.class);

        conn = jmsConnectionFactory.createConnection();
        session = conn.createSession(false,Session.AUTO_ACKNOWLEDGE);
        queueReceiver = (QueueReceiver)session.createConsumer(queue);
        queueReceiver.setMessageListener(new MessageListener(){
            public void onMessage(Message message) {
                System.out.println("QueueReceive Message: " + message);
            }
        });
        conn.start();
    }



    public static void main(String[] args) throws Exception {
        JMSAsyncConsumerTest test = new JMSAsyncConsumerTest();
        test.setUp();
    }
}

