/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms;

import javax.jms.Connection;
import javax.jms.Session;
import javax.naming.InitialContext;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSConnectionTest extends TestCase{
    JMSConnectionFactory jmsConnectionFactory;
    Connection conn;

    public void setUp() throws Exception {
        super.setUp();
        InitialContext ctx = new InitialContext();
        Object cf = ctx.lookup("jms/defaultcf");
        jmsConnectionFactory = (JMSConnectionFactory) javax.rmi.PortableRemoteObject.narrow(cf, JMSConnectionFactory.class);
        conn = jmsConnectionFactory.createConnection();
        conn.start();
    }

    public void tearDown() throws Exception {
        super.tearDown();
    }


    public void testCreateSession() {
        try {
            Session session = conn.createSession(false,Session.AUTO_ACKNOWLEDGE);
            System.out.println(session);
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }

    }
}

