/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms;

import javax.jms.Connection;
import javax.jms.Queue;
import javax.jms.QueueReceiver;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSConsumerTest extends TestCase {
    JMSConnectionFactory jmsConnectionFactory;
    Connection conn;
    Session session;
    Queue queue;
    QueueReceiver queueReceiver;

    public void setUp() throws Exception {
        super.setUp();
        InitialContext ctx = new InitialContext();
        Object cf = ctx.lookup("jms/defaultcf");
        jmsConnectionFactory = (JMSConnectionFactory) javax.rmi.PortableRemoteObject.narrow(cf, JMSConnectionFactory.class);
        queue = (Queue)javax.rmi.PortableRemoteObject.narrow(ctx.lookup("jms/defaultQ1"),Queue.class);

        conn = jmsConnectionFactory.createConnection();
        conn.start();
        session = conn.createSession(false,Session.AUTO_ACKNOWLEDGE);
        queueReceiver = (QueueReceiver)session.createConsumer(queue);
    }

    public void testQueueReceive(){
        try {
            TextMessage message =  (TextMessage)queueReceiver.receive();
            System.out.println("QueueReceive Message: " + message);
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    public static void main(String[] args) {

    }
}

