/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms;

import javax.jms.BytesMessage;
import javax.jms.Connection;
import javax.jms.Queue;
import javax.jms.QueueSender;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSProducerTest extends TestCase {
    JMSConnectionFactory jmsConnectionFactory;
    Connection conn;
    Session session;
    Queue queue;
    QueueSender queueSender;

    public void setUp() throws Exception {
        super.setUp();
        InitialContext ctx = new InitialContext();
        Object cf = ctx.lookup("jms/defaultcf");
        jmsConnectionFactory = (JMSConnectionFactory) javax.rmi.PortableRemoteObject.narrow(cf, JMSConnectionFactory.class);
        queue = (Queue)javax.rmi.PortableRemoteObject.narrow(ctx.lookup("jms/defaultQ1"),Queue.class);

        conn = jmsConnectionFactory.createConnection();
        conn.start();
        session = conn.createSession(false,Session.AUTO_ACKNOWLEDGE);
        queueSender = (QueueSender)session.createProducer(queue);
    }

    protected void tearDown() throws Exception {
        queueSender.close();
        session.close();
        conn.close();
    }

    public void testQueueSend(){
        try {
            TextMessage msg = session.createTextMessage("Hello,JMS!");
            queueSender.send(msg);
            BytesMessage bmsg = session.createBytesMessage();
            queueSender.send(bmsg);
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    public static void main(String[] args) {

    }
}

