/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.jfox.jms;

import javax.jms.Connection;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:yy.young@gmail.com">Young Yang</a>
 */

public class JMSSessionTest extends TestCase {

    JMSConnectionFactory jmsConnectionFactory;
    Connection conn;
    Session session;

    public void setUp() throws Exception {
        super.setUp();
        InitialContext ctx = new InitialContext();
        Object cf = ctx.lookup("jms/defaultcf");
        jmsConnectionFactory = (JMSConnectionFactory) javax.rmi.PortableRemoteObject.narrow(cf, JMSConnectionFactory.class);
        conn = jmsConnectionFactory.createConnection();
        conn.start();
        session = conn.createSession(false,Session.AUTO_ACKNOWLEDGE);
    }

    public void tearDown() throws Exception {
        super.tearDown();
    }

    public void testCreateTextMessage() {
        String s = "Hello,JMS!";
        try{
            TextMessage tm = session.createTextMessage(s);
            assertEquals(s,tm.getText());
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    public void testCreateConsumer(){
        try{
            MessageConsumer consumer = session.createConsumer(new JMSQueue("test"));
            
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    public void testCreateProducer(){
        try{
            MessageProducer producer = session.createProducer(new JMSQueue("test"));
        }
        catch(Exception e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

}

