/* JFox, the OpenSource J2EE Application Server
 *
 * Distributable under GNU LGPL license by gun.org
 * more details please visit http://www.huihoo.org/jfox
 */

package org.jfox.jndi;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import javax.naming.Name;
import javax.naming.Context;

import org.jfox.ioc.connector.ClusterableContainer;
import org.jfox.ioc.connector.Invocation;

/**
 * @author <a href="mailto:young_yy@hotmail.com">Young Yang</a>
 */

public class ClusterableJNDIContainerImpl extends JNDIContainerImpl implements ClusterableContainer {

	/**
	 * ҪClusterͬķ
	 */
	private List<String> clusterMethods = new ArrayList<String>();
	{
		clusterMethods.add("bind");
		clusterMethods.add("rebind");
		clusterMethods.add("unbind");
		clusterMethods.add("createSubcontext");
		clusterMethods.add("destroySubcontext");
		clusterMethods.add("closeSubcontext");
	}

	/**
	 * ClusterableContainer ӿڷClusterHandler
	 * @param invocation
	 */
	public void syncInvocation(Invocation invocation) {
		try {
			Method method = invocation.getMethod();
			Object[] args = invocation.getArgs();
			if(clusterMethods.contains(method.getName())){
				logger.debug("syncInvocation " + invocation);
				// Ҫͬķ
				if(method.getName().equals("bind")) {
					Context ctx = (Context) args[0];
					Name name = (Name) args[1];
					Object bindObject = args[2];
					String className = (String) args[3];
					this.rebind(ctx, name, bindObject, className);
				}
				else {
					method.invoke(this, args);
				}
			}
		}
		catch(Exception e){
			 logger.warn("syncInvocation " + invocation + " error.",e);
		}
	}

	public static void main(String[] args) {

	}
}
